From f8d49b3c91584343123c440208de2e5486e03f3d Mon Sep 17 00:00:00 2001
From: Alexey Min <alexey.min@gmail.com>
Date: Wed, 29 Jul 2020 03:50:27 +0300
Subject: [PATCH 30/59] AlpineApkAuthHelper: clsoe database only on helper exit

Don't be so quick to close database after each operation, close it in
Helper class destructor, on helper exit.
---
 .../AlpineApkBackend/AlpineApkAuthHelper.cpp  | 24 ++++++++++++-------
 .../AlpineApkBackend/AlpineApkAuthHelper.h    |  1 +
 2 files changed, 16 insertions(+), 9 deletions(-)

diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
index f5d8e17e5..e6e6cb7a1 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
@@ -40,8 +40,18 @@ using namespace KAuth;
 
 AlpineApkAuthHelper::AlpineApkAuthHelper() {}
 
+AlpineApkAuthHelper::~AlpineApkAuthHelper()
+{
+    closeDatabase();
+}
+
 bool AlpineApkAuthHelper::openDatabase(const QVariantMap &args, bool readwrite)
 {
+    // is already opened?
+    if (m_apkdb.isOpen()) {
+        return true;
+    }
+
     // maybe set fakeRoot (needs to be done before Database::open()
     const QString fakeRoot = args.value(QLatin1String("fakeRoot"), QString()).toString();
     if (!fakeRoot.isEmpty()) {
@@ -62,7 +72,11 @@ bool AlpineApkAuthHelper::openDatabase(const QVariantMap &args, bool readwrite)
 
 void AlpineApkAuthHelper::closeDatabase()
 {
-    m_apkdb.close();
+    // close database only if opened
+    if (m_apkdb.isOpen()) {
+        // this also stops bg thread
+        m_apkdb.close();
+    }
 }
 
 void AlpineApkAuthHelper::setupTransactionPostCreate(QtApk::Transaction *trans)
@@ -142,9 +156,7 @@ ActionReply AlpineApkAuthHelper::update(const QVariantMap &args)
         });
     }
 
-    closeDatabase();
     HelperSupport::progressStep(100);
-
     return m_actionReply;
 }
 
@@ -177,9 +189,7 @@ ActionReply AlpineApkAuthHelper::add(const QVariantMap &args)
         m_actionReply = ActionReply::SuccessReply();
     }
 
-    closeDatabase();
     HelperSupport::progressStep(100);
-
     return m_actionReply;
 }
 
@@ -219,9 +229,7 @@ ActionReply AlpineApkAuthHelper::del(const QVariantMap &args)
         m_actionReply = ActionReply::SuccessReply();
     }
 
-    closeDatabase();
     HelperSupport::progressStep(100);
-
     return m_actionReply;
 }
 
@@ -265,9 +273,7 @@ ActionReply AlpineApkAuthHelper::upgrade(const QVariantMap &args)
         m_actionReply.setData(replyData);
     }
 
-    closeDatabase();
     HelperSupport::progressStep(100);
-
     return m_actionReply;
 }
 
diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h
index eed39f283..7fd69a8f3 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h
@@ -32,6 +32,7 @@ class AlpineApkAuthHelper : public QObject
     Q_OBJECT
 public:
     AlpineApkAuthHelper();
+    ~AlpineApkAuthHelper() override;
 
 public Q_SLOTS:
     ActionReply update(const QVariantMap &args);
-- 
GitLab


